{
  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let pkgs = import nixpkgs { inherit system; };
      in {
        legacyPackages = pkgs;

        devShell = pkgs.mkShell {
          packages = with pkgs; [
            (python3.withPackages
              (p: with p; [ more-itertools tqdm autologging ]))
            ruby
            swiProlog
            yabasic
            rustc
            rustfmt
            cargo
            fuse
            pkg-config
          ];

          PKG_CONFIG_PATH = "${pkgs.fuse}/lib/pkgconfig";
        };
      });
}
