from autologging import traced, TRACE
import math
import functools
import logging, sys

# logging.basicConfig(level=TRACE, stream=sys.stdout, format="%(levelname)s:%(name)s:%(funcName)s:%(message)s")

with open("13.txt") as f:
  data = f.read()

ex_data = """[1,1,3,1,1]
[1,1,5,1,1]

[[1],[2,3,4]]
[[1],4]

[9]
[[8,7,6]]

[[4,4],4,4]
[[4,4],4,4,4]

[7,7,7,7]
[7,7,7]

[]
[3]

[[[]]]
[[]]

[1,[2,[3,[4,[5,6,7]]]],8,9]
[1,[2,[3,[4,[5,6,0]]]],8,9]"""

@traced
def compare(left, right):
  if type(left) == int and type(right) == int:
    if left == right: return None
    return left < right
  elif type(left) == list and type(right) == list:
    for left_el, right_el in zip(left, right):
      res = compare(left_el, right_el)
      if res is None: continue
      return res
    if len(left) > len(right): return False
    elif len(left) == len(right): return None
    return True
  else:
    if type(left) == int: left = [left]
    if type(right) == int: right = [right]
    return compare(left, right)

def solve1(data):
  packets = data.split("\n\n")

  correct = set()
  for i, packet in enumerate(packets):
    first, second = packet.strip().split("\n")
    first = eval(first)
    second = eval(second)

    idx = i + 1
    # print(idx)
    if compare(first, second) == True: correct.add(idx)

  print(sum(correct))

def solve2(data):
  packets = data.splitlines()
  packets = map(lambda s: s.strip(), packets)
  packets = filter(lambda s: s != "", packets)
  packets = map(lambda s: eval(s), packets)
  packets = list(packets)
  packets.append([[2]])
  packets.append([[6]])

  def compare2(a, b):
    res = compare(a, b)
    if res == True: return -1
    elif res == False: return 1
    else: return 0

  packets.sort(key = functools.cmp_to_key(compare2))
  
  wanted = enumerate(packets)
  wanted = filter(lambda c: c[1] == [[2]] or c[1] == [[6]], wanted)
  wanted = map(lambda c: c[0] + 1, wanted)
  wanted = list(wanted)
  print(math.prod(wanted))

solve1(ex_data)
solve1(data)

solve2(ex_data)
solve2(data)
